package it.inaf.oats.ia2.tap.tsm.model;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;

/**
 *
 * @author pietro
 */
public class Column extends DbEntity {

    // editable properties
    public static final String UTYPE = "utype";
    public static final String UCD = "ucd";
    public static final String UNIT = "unit";
    public static final String DESCRIPTION = "description";
    public static final String STD = "std";
    
    // uneditable properties
    //public static final String DESCRIPTION = "description";
    
    
    private String tableName;
    private String name;

//    private final EditableValue<String> utype;
//    private final EditableValue<String> ucd;
//    private final EditableValue<String> unit;
//    private final EditableValue<String> description;
//    private final EditableValue<Boolean> std;

    private String datatype;
    private int size;

    private boolean isPrimaryKey;
    private boolean isForeignKey;
    private boolean principal;
    private boolean indexed;

    public Column() {
        super(UTYPE, UCD, UNIT, DESCRIPTION, STD);
        setStatus(Status.NOT_SELECTED);

//        utype = new EditableValue<String>();
//        ucd = new EditableValue<String>();
//        unit = new EditableValue<String>();
//        description = new EditableValue<String>();
//        std = new EditableValue<Boolean>();
    }

//    public EditableValue<String> getUtypeEditableValue() {
//        return utype;
//    }
//
//    public EditableValue<String> getUcdEditableValue() {
//        return ucd;
//    }
//
//    public EditableValue<String> getUnitEditableValue() {
//        return unit;
//    }
//
//    public EditableValue<String> getDescriptionEditableValue() {
//        return description;
//    }
//
//    public EditableValue<Boolean> getStdEditableValue() {
//        return std;
//    }
//    private void setValue(ColumnField key, Serializable value) {
//        if (properties.containsKey(key)) {
//            properties.get(key).setValue(value);
//        } else {
//            properties.put(key, new EditableValue(value));
//        }
//    }
//    private Object getValue(ColumnField key) {
//        EditableValue value = properties.get(key);
//        if (value != null) {
//            return value.getValue();
//        }
//        return null;
//    }
//    private boolean checked;

    public String getTableName() {
        return tableName;
    }

    public void setTableName(String tableName) {
        this.tableName = tableName;
    }

    @Override
    public String getName() {
        return name;
    }

    public void setName(String columnName) {
        this.name = columnName;
    }

//    public String getUtype() {
//        return getValue(UTYPE);
//    }
//
//    public void setUtype(String utype) {
//        setValue(UTYPE, utype);
//    }
//
//    public String getUcd() {
//        return getValue(UCD);
//    }
//
//    public void setUcd(String ucd) {
//        setValue(UCD, ucd);
//    }
//
//    public String getUnit() {
//        return getValue(UNIT);
//    }
//
//    public void setUnit(String unit) {
//        setValue(UNIT, unit);
//    }
//
//    public String getDescription() {
//        return getValue(DESCRIPTION);
//    }
//
//    public void setDescription(String description) {
//        setValue(DESCRIPTION, description);
//    }

    public String getDatatype() {
        return datatype;
    }

    public void setDatatype(String datatype) {
        this.datatype = datatype;
    }

    public int getSize() {
        return size;
    }

    public void setSize(int size) {
        this.size = size;
    }

    public boolean getPrincipal() {
        return principal;
    }

    public void setPrincipal(boolean principal) {
        this.principal = principal;
    }

    public boolean getIndexed() {
        return indexed;
    }

    public void setIndexed(boolean indexed) {
        this.indexed = indexed;
    }

    public boolean getStd() {
        return Boolean.parseBoolean(getValue(STD));
    }

    public void setStd(boolean std) {
        setValue(STD, std + "");
    }

    public boolean isPrimaryKey() {
        return isPrimaryKey;
    }

    public void setIsPrimaryKey(boolean value) {
        isPrimaryKey = value;
    }

    public boolean isForeignKey() {
        return isForeignKey;
    }

    public void setIsForeignKey(boolean value) {
        isForeignKey = value;
    }

//    @Override
//    public String getOriginalValue(String key) {
//        if (key.equals(UTYPE)) {
//            return this.getUtype();
//        }
//        if (key.equals(UCD)) {
//            return this.getUcd();
//        }
//        if (key.equals(UNIT)) {
//            return this.getUnit();
//        }
//        if (key.equals(DESCRIPTION)) {
//            return this.getDescription();
//        }
//        if (key.equals(STD)) {
//            return this.getStd() + "";
//        }
//        return null;
//    }

    @Override
    public void update(Connection connection) throws SQLException {
        PreparedStatement statement = null;
        try {
            statement = connection.prepareStatement("UPDATE `columns` "
                    + "SET utype = ?, ucd = ?, unit = ?, description = ?, std = ? "
                    + "WHERE column_name = ? AND table_name = ?");
            statement.setString(1, getValue(UTYPE));
            statement.setString(2, getValue(UCD));
            statement.setString(3, getValue(UNIT));
            statement.setString(4, getValue(DESCRIPTION));
            statement.setInt(5, Boolean.parseBoolean(getValue(STD)) ? 1 : 0);
            statement.setString(6, getName());
            statement.setString(7, getTableName());
            statement.executeUpdate();
        } catch (SQLException e) {
            throw e;
        } finally {
            if (statement != null) {
                statement.close();
            }
        }
    }

    @Override
    public void insert(Connection connection) throws SQLException {
        PreparedStatement statement = null;
        try {
            statement = connection.prepareStatement("INSERT INTO `columns` "
                    + "(table_name, column_name, utype, ucd, unit, description, "
                    + "datatype, size, principal, indexed, std, columnID) "
                    + "VALUES(?,?,?,?,?,?,?,?,?,?,?,null)");
            statement.setString(1, getTableName());
            statement.setString(2, getName());
            statement.setString(3, getValue(UTYPE));
            statement.setString(4, getValue(UCD));
            statement.setString(5, getValue(UNIT));
            statement.setString(6, getValue(DESCRIPTION));
            statement.setString(7, getDatatype());
            statement.setInt(8, getSize());
            statement.setInt(9, getPrincipal() ? 1 : 0);
            statement.setInt(10, getIndexed() ? 1 : 0);
            statement.setInt(11, Boolean.parseBoolean(getValue(STD)) ? 1 : 0);
            statement.executeUpdate();
        } catch (SQLException e) {
            throw e;
        } finally {
            if (statement != null) {
                statement.close();
            }
        }
    }
}
