
import it.inaf.oats.ia2.tap.tsm.datalayer.TapSchemaDL;
import it.inaf.oats.ia2.tap.tsm.model.Credentials;
import it.inaf.oats.ia2.tap.tsm.model.DbEntity;
import it.inaf.oats.ia2.tap.tsm.model.Schema;
import it.inaf.oats.ia2.tap.tsm.model.Table;
import it.inaf.oats.ia2.tap.tsm.model.TapSchema;
import java.sql.Connection;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author Sonia Zorba <zorba at oats.inaf.it>
 */
public class TestUtils {

    public static Credentials getCredentials() {
        return new Credentials("localhost", 3306, "root", "root");
    }

    public static TapSchema getNewTAPSchemaOneSchemaSelected(Connection connection) throws SQLException {
        String firstSchema = TapSchemaDL.getAllSchemasNames(connection).get(0);
        ArrayList<String> selectedSchemas = new ArrayList<String>();
        selectedSchemas.add(firstSchema);

        return new TapSchema(connection, "TEST", selectedSchemas);
    }

    public static Schema getFirstNotNullSchema(TapSchema tapSchema) throws BadMockDbException {
        for (DbEntity schema : tapSchema.getAllEntities()) {
            return (Schema) schema;
        }
        throw new BadMockDbException();
    }

    public static String getFirstNullSchema(TapSchema tapSchema) throws BadMockDbException {
        for (String schemaName : tapSchema.getSchemasNames()) {
            if (tapSchema.getSchema(schemaName) == null) {
                return schemaName;
            }
        }
        throw new BadMockDbException();
    }

    public static Table getFirstTableNotNull(Schema schema) throws BadMockDbException {
        for (DbEntity table : schema.getAllEntities()) {
            return (Table) table;
        }
        throw new BadMockDbException();
    }

    public static String getFirstNullTable(Schema schema) throws BadMockDbException {
        List<String> addablesTables = schema.getAddables();
        if (addablesTables.size() > 0) {
            return addablesTables.get(0);
        }
        throw new BadMockDbException();
    }
}
