/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package it.inaf.oats.ia2.tap.utils;

import it.inaf.oats.ia2.tap.utils.model.Credentials;
import java.sql.Connection;
import java.sql.SQLException;
import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.form.*;
import org.apache.wicket.model.CompoundPropertyModel;
import org.apache.wicket.model.Model;
import org.apache.wicket.validation.IValidatable;
import org.apache.wicket.validation.IValidator;

/**
 * CredentialPage class extends the default BasePage class and is the home page.
 * It obtains the MySQL credentials from the user and pass them to the
 * SelectSchemataPage with the onSubmit method of the credentialSubmit
 * AjaxSubmitLink.
 *
 * @author pietro
 */
public class CredentialPage extends BasePage {

    Form credentialForm;

    final TextField<String> hostnameTextField = new TextField<String>("hostname");
    final NumberTextField<Integer> portTextField = new NumberTextField<Integer>("port");
    final TextField<String> usernameTextField = new TextField<String>("username");
    final PasswordTextField passwordTextField = new PasswordTextField("password");

    /**
     * CredentialPage constructor
     */
    public CredentialPage() {
        super("TapSchema Manager - Credentials insertion page");
        
        //credential form
        final Credentials credentials = new Credentials();
        credentialForm = new Form<Credentials>("credentialForm", new CompoundPropertyModel<Credentials>(credentials)) {
            @Override
            protected void onSubmit() {
                super.onSubmit();

                Connection connection = null;
                try {
                    connection = credentials.getConnection();
                    // passes the credentials to SelectSchemataPage
                    SelectSchemataPage selectSchemataPage
                            = new SelectSchemataPage(credentials, connection);
                    setResponsePage(selectSchemataPage);
                } catch (SQLException exception) {
                    addError("Exception occurred in submitting credentials: " + (String) exception.getMessage());
                } finally {
                    try {
                        connection.close();
                    } catch (Exception exception) {
                        exception.printStackTrace();
                    }
                }
            }

            @Override
            protected void onError() {
                super.onError();
                addError("Error occurred in submitting form");
            }

        };
        credentialForm.add(hostnameTextField);
        credentialForm.add(portTextField);
        credentialForm.add(usernameTextField);
        credentialForm.add(passwordTextField);
        add(credentialForm);

//            @Override
//            protected void onEvent(AjaxRequestTarget target) {
//                //Extract the keycode parameter from RequestCycle
//                final Request request = RequestCycle.get().getRequest();
//                final String jsKeycode = request.getRequestParameters()
//                        .getParameterValue("keycode").toString("");
//
//                if (jsKeycode.equals("13")) //if Enter key
//                {
//                    infoTextArea.setModelObject((String) infoTextArea.getModelObject()
//                            + "\nClosing session...");
//                }
//                target.add(infoTextArea);
//            }
//        });
//        credentialForm.add(exit);
    }
}
