package it.inaf.oats.ia2.tap.utils;

import it.inaf.oats.ia2.tap.utils.panel.SchemaPanel;
import it.inaf.oats.ia2.tap.utils.model.IDbEntity;
import it.inaf.oats.ia2.tap.utils.model.Schema;
import it.inaf.oats.ia2.tap.utils.model.Status;
import it.inaf.oats.ia2.tap.utils.model.Table;
import it.inaf.oats.ia2.tap.utils.panel.TablePanel;
import org.apache.wicket.extensions.markup.html.tabs.AbstractTab;
import org.apache.wicket.markup.html.panel.Panel;
import org.apache.wicket.model.Model;

/**
 * 
 *
 * @author pietro
 */
public class DbEntityTab extends AbstractTab {

    private final Panel panel;
    private final IDbEntity dbEntity;

    public DbEntityTab(SchemaPage schemaPage, String panelId, Schema schema) {
        super(new Model<String>(schema.getName()));
        this.dbEntity = schema;
        panel = new SchemaPanel(schemaPage, panelId, schema);
    }
    
    public DbEntityTab(SchemaPage schemaPage, String panelId, Table table) {
        super(new Model<String>(table.getName()));
        this.dbEntity = table;
        panel = new TablePanel(schemaPage, panelId, table);
    }

    @Override
    public Panel getPanel(String panelId) {
        return panel;
    }
    
    public Status getStatus() {
        return dbEntity.getStatus();
    }
}
