/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package it.inaf.oats.ia2.tap.utils;

import it.inaf.oats.ia2.tap.utils.model.Credentials;
import it.inaf.oats.ia2.tap.utils.model.Schema;
import it.inaf.oats.ia2.tap.utils.model.TapSchema;
import java.util.ArrayList;
import java.util.List;
import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.ajax.form.AjaxFormComponentUpdatingBehavior;
import org.apache.wicket.behavior.AttributeAppender;
import org.apache.wicket.extensions.ajax.markup.html.tabs.AjaxTabbedPanel;
import org.apache.wicket.extensions.markup.html.tabs.ITab;
import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.form.Form;
import org.apache.wicket.markup.html.panel.Panel;
import org.apache.wicket.model.Model;
import org.apache.wicket.model.PropertyModel;

/**
 * SchemaPanel class extends Panel class, to have a panel for every schema.
 * SchemaPanel class has an AjaxTabbedPanel to show the TableTabs dinamically.
 *
 * @author pietro
 */
public class SchemaPanelOld extends Panel {

    final UtypeDescription utypeDescription;

    public final AjaxTextField utypeText;
    public final AjaxTextField descriptionText;
    public final AjaxCheckBoxCustom selectSchemaCheckBox;
    List<ITab> tablesTabs;
    public AjaxTabbedPanel tablesTabbedPanel;

    public String schema_name;

    /**
     * SchemaPanel constructor
     *
     * @param id
     * @param credential
     * @param tapschemaName
     * @param tapschema tapschema structure
     * @param schema current schema structure
     */
    public SchemaPanelOld(
            String id,
            final Credentials credential,
            final String tapschemaName,
            final TapSchema tapschema,
            Schema schema) {
        super(id);

        this.schema_name = schema.name;

        utypeDescription = new UtypeDescription(schema.getUtype(), schema.getDescription());

        //update schema form
        Form updateSchemaForm = new Form("updateSchemaForm");
        add(updateSchemaForm);

        //select schema label
        Label selectSchemaLabel = new Label("selectSchemaLabel", new Model("Select " + schema_name));
        updateSchemaForm.add(selectSchemaLabel);

        //select schema checkbox
        selectSchemaCheckBox = new AjaxCheckBoxCustom("selectSchemaCheckBox", new Model(schema.isChecked()));
        selectSchemaCheckBox.setIdString(
                schema.name + "-"
                + "checked");
        selectSchemaCheckBox.add(new AjaxFormComponentUpdatingBehavior("onchange") {
            /**
             * onUpdate method of selectSchemaCheckBox sets the variable
             * "checked" in the correct schema of tapschema structure
             *
             * @param target
             */
            @Override
            protected void onUpdate(AjaxRequestTarget target) {
                SchemaPage schemaPage = (SchemaPage) getPage();
                String[] idSplit = selectSchemaCheckBox.getIdString().split("-");
                if (idSplit[1].equals("checked")) {
                    schemaPage.tapSchema.getSchema(idSplit[0])
                            .setChecked((boolean) selectSchemaCheckBox.getModelObject());
                }
            }
        });
        selectSchemaCheckBox.setOutputMarkupPlaceholderTag(true);
        updateSchemaForm.add(selectSchemaCheckBox);

        //utype label
        Label utypeLabel = new Label("utypeLabel", new Model(schema_name + " utype"));
        updateSchemaForm.add(utypeLabel);

        //utype textfield
        utypeText = new AjaxTextField(
                "utypeText",
                new PropertyModel(utypeDescription, "utype"));
        utypeText.setIdString(
                schema.name + "-"
                + "utype");
        utypeText.setOutputMarkupPlaceholderTag(true);
        utypeText.add(new AttributeAppender("style", "width: 400px"));
        updateSchemaForm.add(utypeText);

        //description label
        Label descriptionLabel = new Label("descriptionLabel", new Model(schema_name + " description"));
        updateSchemaForm.add(descriptionLabel);

        //description textfield
        descriptionText = new AjaxTextField(
                "descriptionText",
                new PropertyModel(utypeDescription, "description"));
        descriptionText.setIdString(
                schema.name + "-"
                + "description");
        descriptionText.setOutputMarkupPlaceholderTag(true);
        descriptionText.add(new AttributeAppender("style", "width: 400px"));
        updateSchemaForm.add(descriptionText);

        //tables AjaxTabbedPanel
        tablesTabs = new ArrayList<ITab>();
        tablesTabbedPanel = new AjaxTabbedPanel("tablesTabbedPanel", tablesTabs);
        tablesTabbedPanel.setOutputMarkupPlaceholderTag(true);
        add(tablesTabbedPanel);
    }

}
