package it.inaf.oats.ia2.tap.utils.datalayer;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

/**
 *
 * @author Sonia Zorba <zorba at oats.inaf.it>
 */
public abstract class ResultSetReader {

    private final String query;

    public ResultSetReader(String query) {
        this.query = query;
    }

    public abstract void manipulateItem(ResultSet resultSet) throws SQLException;

    public final void read(Connection connection) throws SQLException {
        Statement statement = null;
        ResultSet resultSet = null;
        try {
            statement = connection.createStatement();
            resultSet = statement.executeQuery(query);
            while (resultSet.next()) {
                manipulateItem(resultSet);
            }
        } catch (SQLException e) {
            throw e;
        } finally {
            if (resultSet != null) {
                resultSet.close();
            }
            if (statement != null) {
                statement.close();
            }
        }
    }
}
